library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity fourbit_counter is
  port ( 
    clk_50 : in STD_LOGIC;
    Q : out STD_LOGIC_VECTOR (3 downto 0)
  );
end fourbit_counter;


architecture my_structural of fourbit_counter is

  component my_tff
    port ( 
      T : in STD_LOGIC;
      clk : in STD_LOGIC;
      Q, QN : out STD_LOGIC
    );
  end component;

  -- for simulation purposes is good to initialize signals;
  signal all_T, S0, S1, S2, S3 : STD_LOGIC := '0';

begin

-- signal all_T is used to drive to logic '1' the T inputs of the flip-flops;
-- see diagram: http://dejazzer.com/eece4740/lectures/lec02_fourbit_counter.pdf
all_T <= '1';
 
TFF0: my_tff port map (T => all_T, clk => clk_50, Q => Q(0), QN => S0);
TFF1: my_tff port map (T => all_T, clk => S0, Q => Q(1), QN => S1);
TFF2: my_tff port map (T => all_T, clk => S1, Q => Q(2), QN => S2);
TFF3: my_tff port map (T => all_T, clk => S2, Q => Q(3), QN => S3); -- S3 not really used for anything;

end my_structural;

