LIBRARY IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity fourbit_counter_testbench is
end fourbit_counter_testbench;


architecture my_tb_arch of fourbit_counter_testbench is 


  component fourbit_counter
  port ( 
    clk_50 : in STD_LOGIC;
    Q : out STD_LOGIC_VECTOR (3 downto 0)
  );
  end component;
  

  for U1_instance_of_fourbit_counter: fourbit_counter use entity WORK.FOURBIT_COUNTER(my_structural);
  signal clk_local : std_logic; 
  signal local_q : STD_LOGIC_VECTOR(3 downto 0);

	
  begin
   
   
  -- (1) instantiate design under test (DUT);
  U1_instance_of_fourbit_counter : fourbit_counter port map (
    clk_50 => clk_local, 
    Q => local_q
  );
  
  
  -- (2) process to generate clock signal; let's say we use a clock signal 
  -- with period 100 ns; you should have a clock generation process like
  -- this, in a separate processes of its own, for any testbench of nay
  -- sequential circuit!
  clk_generation : process 
  begin
    clk_local <= '0'; wait for 50 ns;
    clk_local <= '1'; wait for 50 ns;
  end process clk_generation;
  
  
  -- (3) process to generate desired input stimuli, such as 
  -- reset signals values, or primary inputs into this sequential circuit;
  -- in the case of the fourbit_counter this is not needed because
  -- the counter takes as input just a clk signal, which is generated
  -- from within the other process, that was meant only for "clock generation";
  -- so, this is an empty process, inserted here as just a place holder;
  -- uncomment to use;
  --DUT_inputs_stimuli: process
  --begin
    -- insert here PIs assignments;
  --end process dut_inputs_stimuli;
  
  
end my_tb_arch;


